﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Syncfusion.Windows.Controls.Grid;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace WpfApplication1
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        List<MenuItem> menuitems = new List<MenuItem>();
        public MainWindow()
        {
            InitializeComponent();
            this.gridTreeControl1.ModelLoaded += (s, e) =>
                {
                    new DragNodeHelper<BusinessObject>(gridTreeControl1);
                    gridTreeControl1.Dispatcher.BeginInvoke(new Action(() =>
                        {
                            gridTreeControl1.CollapseAllNodes();
                        }), null);
                };

            this.gridTreeControl1.Model.EnableContextMenu = true;
            this.gridTreeControl1.Model.QueryContextMenuInfo += Model_QueryContextMenuInfo;
            MenuItem item = new MenuItem() { Header = "Menu" };
            item.Click += Item_Click;
            menuitems.Add(item);
        }

        private void Item_Click(object sender, RoutedEventArgs e)
        {
            var menu = sender as MenuItem;
            if(menu.CommandParameter is GridStyleInfo)
            {
                var style = menu.CommandParameter as GridStyleInfo;
                var node = gridTreeControl1.InternalGrid.GetNodeAtRowIndex(style.RowIndex);
                var data = node.Item as BusinessObject;
            }
        }

        private void Model_QueryContextMenuInfo(object sender, GridQueryContextMenuInfoEventArgs e)
        {
            menuitems.ForEach(mi => mi.CommandParameter = e.Style);
            e.Style.ContextMenuItems = menuitems;
        }
    }
}
